#include "osecpu.h"

void putKeybuf(int i)
{
	if (keybuf_c < KEYBUFSIZ) {
		keybuf[keybuf_w] = i;
		keybuf_c++;
		keybuf_w = (keybuf_w + 1) & (KEYBUFSIZ - 1);
	}
	return;
}

int osecpuMain(int argc, char **argv)
{
	unsigned char *appbin = malloc(APPSIZ1), *up;
	unsigned char *jitbuf = mallocRWE(1024 * 1024); /* とりあえず1MBで */
	//unsigned char *sysjit0 = mallocRWE(SJITSIZ1), *sysjit1 = sysjit0, *sysjit00 = sysjit0;

	// syslib.oseのjitc結果を格納する領域を確保。
	unsigned char *sysjit00 = mallocRWE(SJITSIZ1);

	// 現在の、jitc結果を格納するメモリへの書き込み位置のアドレス
	unsigned char *sysjit = sysjit00;

	unsigned char *systmp0 = malloc(SYSTMP0SIZ);
	unsigned char *systmp1 = malloc(SYSTMP1SIZ);
	unsigned char *systmp2 = malloc(1024 * 1024), *opTbl = malloc(256);
	struct LabelTable *label = malloc(JITC_MAXLABELS * sizeof (struct LabelTable));
	int level = JITC_LV_SLOWEST, tmpsiz, i;
	keybuf = malloc(KEYBUFSIZ * sizeof (int));
	keybuf_r = keybuf_w = keybuf_c = 0;
	jmp_buf setjmpEnv;
	double tm0, tm1, tm2;
	struct PtrCtrl *ptrCtrl = malloc(PTRCTRLSIZ * sizeof (struct PtrCtrl));

	randStatInit((unsigned int)time(NULL));
	for (i = 0; i < PTRCTRLSIZ; i++) {
		ptrCtrl[i].liveSign = 0;
		ptrCtrl[i].size = -1;
	}
	ptrCtrl[0].size = -2;

	/* syslibの読み込み */
	unsigned char *syslib = malloc(SYSLIBSIZ1);
	int appsiz0, appsiz1;
	FILE *fp = fopen(SYSLIB_OSE, "rb");
	if (fp == NULL) {
		syslib[0] = '/';
		strcpy(syslib + 1, argv[0]);
		up = syslib + 1;
		while (*up != '¥0') up++;
		while (*up != '/' && *up != 0x5c) up--;
		up++;
		strcpy(up, SYSLIB_OSE);
		fp = fopen(syslib + 1, "rb");
	}
	if (fp == NULL) {
		fputs("syslib-file fopen error.¥n", stderr);
		return 1;
	}
	appsiz0 = fread(syslib, 1, SYSLIBSIZ1 - 4, fp);
	fclose(fp);
	if (appsiz0 >= SYSLIBSIZ1 - 4) {
		fputs("syslib-file too large.¥n", stderr);
		return 1;
	}
	if (syslib[0] == 0x05 && syslib[1] == 0xc1) {
		
		// 一体この部分ではなにをやっているのだろう?

		memcpy(systmp0, syslib, appsiz0);
		ComLib_main(systmp0 + 2, syslib + 2);
		syslib[0] = 0x05;
		syslib[1] = 0x1b;
	}

	FILE *fp2 = fopen("syslib_dbg.ose", "wb");
	fwrite(syslib, 1, SYSLIBSIZ1, fp2);
	fclose(fp2);

	// jutc.cのerrHndl()をCALLするネィティブコードを挿入。
	// sysjitの値は次の書き込み位置へずらされる。
	// 元々のsysjitはsysjit00へ保存されている。
	sysjit = jitCompInit(sysjit);

	// sysjit (アドレス変数)は下の関数の実行で変更される(だから参照渡し)
	// もちろんsysjitの値は次の書き込み位置へずらされる。
	// labelはjitc0()内で初期化される。
	i = jitc0(&sysjit, sysjit00 + SJITSIZ1, syslib + 32, syslib + SYSLIBSIZ1, JITC_LV_FASTEST, label);
	if (i != 0) {
		fputs("syslib-file JITC error.¥n", stderr);
		return 1;
	}

	// エラー時にデバッグ用に表示する変数を加算
	di1_serial++;

	/* アプリバイナリの読み込み */
	if (argc <= 1) { return 0; }
	const unsigned char *argv1 = argv[1];
	if (argv1[0] == ':' && argv1[2] == ':') {
		level = argv1[1] - '0';
		if (level < 0 || level > 9)
			level = JITC_LV_SLOWEST;
		argv1 += 3;
	}
	fp = fopen(argv1, "rb");
	if (fp == NULL) {
		fputs("app-file load error.¥n", stderr);
		return 1;
	}
	appsiz1 = appsiz0 = fread(appbin, 1, APPSIZ1 - 4, fp);
	fclose(fp);
	if (appsiz0 >= APPSIZ1 - 4) {
		fputs("app-file too large.¥n", stderr);
		return 1;
	}
	if (appsiz0 < 3) {
	header_error:
		fputs("app-file header error.¥n", stderr);
		return 1;
	}

	tm0 = clock() / (double)CLOCKS_PER_SEC;

	if (appbin[2] == 0xf0) {
#if (USE_TEK5 != 0)
		appsiz1 = tek5Decomp(appbin + 2, appbin + appsiz0, systmp0) + 2;
#else
		appsiz1 = -9;
#endif
		if (appsiz1 < 0) {
			fputs("unsupported-format(tek5)¥n", stderr);
			return 1;
		}
	}

	int argDebug = 0, stacksiz = 1;
	const unsigned char *cp = searchArg(argc, argv, "debug:", 0);
	if (cp != NULL) argDebug = *cp - '0';
	cp = searchArg(argc, argv, "stack:", 0);
	if (cp != NULL) stacksiz = strtol(cp, NULL, 0);

	struct Regs regs;
	void(*jitfunc)(char *);
	unsigned char *jp = jitbuf; /* JIT-pointer */

	/* フロントエンドコードをバックエンドコードに変換する */
	if ((appbin[2] & 0xf0) != 0) {
		systmp0[0] = appbin[0];
		systmp0[1] = appbin[1];
		regs.preg[2].p = systmp0 + 2;
		regs.preg[3].p = systmp0 + SYSTMP0SIZ;
		regs.preg[4].p = appbin + 2;
		regs.preg[5].p = appbin + appsiz1;
		regs.preg[6].p = systmp1;
		regs.preg[7].p = systmp1 + SYSTMP1SIZ;
		regs.preg[10].p = systmp2;
		int pxxFlag[64], typLabel[4096];
		regs.preg[0x0b].p = (void *)pxxFlag;
		regs.preg[0x0c].p = (void *)typLabel;
		regs.preg[0x0d].p = opTbl;
		jitfunc = (void *)sysjit;
		(*jitfunc)(((char *)&regs) + 128); /* サイズを節約するためにEBPを128バイトずらす */
		if (regs.ireg[0] != 0) {
			jp = regs.preg[2].p - 1;
			fprintf(stderr, "unpack error: %02X (at %06X) (R00=%d)¥n", *jp, jp - systmp0, regs.ireg[0]);
			if ((argDebug & 2) != 0) {
				fp = fopen("debug2.bin", "wb");
				fwrite(systmp0, 1, jp - systmp0 + 16, fp);
				fclose(fp);
			}
			exit(1);
		}
		tmpsiz = regs.preg[2].p - systmp0;
	}
	else {
		memcpy(systmp0, appbin, appsiz1);
		tmpsiz = appsiz1;
	}

	if ((argDebug & 2) != 0) {
		fp = fopen("debug2.bin", "wb");
		fwrite(systmp0, 1, tmpsiz, fp);
		fclose(fp);
	}

	i = jitc0(&jp, jitbuf + 1024 * 1024, systmp0, systmp0 + tmpsiz, level, label);
	if (i == 1) goto header_error;
	if (i != 0) return 1;
	di1_serial++;

	int appsiz2 = jp - jitbuf;

	unsigned char *p28 = jp;
	jp = jitCompCallFunc(jp, &devFunc);

	tm1 = clock() / (double)CLOCKS_PER_SEC;

	/* レジスタ初期化 */
	for (i = 0; i < 64; i++)
		regs.ireg[i] = 0;
	for (i = 0; i < 64; i++) {
		regs.preg[i].p = NULL;
		regs.preg[i].typ = -1;
		regs.preg[i].p0 = NULL;
		regs.preg[i].p1 = NULL;
	}

	regs.argc = argc;
	regs.argv = argv;
	regs.buf0 = regs.buf1 = NULL;
	regs.preg[0x28].p = p28;
	regs.preg[0x28].typ = 0; // TYP_CODE
	regs.preg[0x28].p0 = p28;
	regs.preg[0x28].p1 = p28 + 1;
	//	regs.preg[0x00].p = malloc(1024 * 1024) + (1024 * 1024 - 32);
	regs.junkStack = malloc(stacksiz << 20);
	regs.junkStack1 = regs.junkStack + (stacksiz << 20);
	regs.winClosed = 0;
	regs.autoSleep = 0;
	regs.setjmpEnv = &setjmpEnv;
	regs.lastConsoleChar = '¥n';

	regs.label = label;
	regs.maxLabels = JITC_MAXLABELS;
	regs.jitbuf = jp;
	regs.jitbuf1 = jitbuf + 1024 * 1024;
	regs.errHndl = &errorHandler;
	regs.dbgr = 0;
	if (searchArg(argc, argv, "dbgr:1", 0) != NULL) regs.dbgr = 1;

	if ((argDebug & 1) != 0) {
		fp = fopen("debug1.bin", "wb");
		fwrite(jitbuf, 1, jp - jitbuf, fp);
		fclose(fp);
	}

	/* JITコード実行 */
	jitfunc = (void *)jitbuf;
	if (setjmp(setjmpEnv) == 0)
		(*jitfunc)(((char *)&regs) + 128); /* サイズを節約するためにEBPを128バイトずらす */
	if (regs.autoSleep != 0) {
		if (vram != NULL)
			drv_flshWin(v_xsiz, v_ysiz, 0, 0);
		while (regs.winClosed == 0)
			drv_sleep(100);
	}
	if (regs.lastConsoleChar != '¥n')
		putchar('¥n');

	tm2 = clock() / (double)CLOCKS_PER_SEC;

	/* 実行結果確認のためのレジスタダンプ */
	if (searchArg(argc, argv, "verbose:1", 0) != NULL) {
		printf("time: JITC=%.3f[sec], exec=%.3f[sec]¥n", tm1 - tm0, tm2 - tm1);
		printf("size: OSECPU=%d, decomp=%d, tmp=%d, native=%d¥n", appsiz0, appsiz1, tmpsiz, appsiz2);
		printf("result:¥n");
		printf("R00:0x%08X  R01:0x%08X  R02:0x%08X  R03:0x%08X¥n", regs.ireg[0], regs.ireg[1], regs.ireg[2], regs.ireg[3]);
	}
#if (USE_DEBUGGER != 0)
	dbgrMain(&regs);
#endif
	return 0;
}

int main(int argc, char **argv)
{
	// Program entry point

	return osecpuMain(argc, argv);
}