#ifndef _HDLOAD_OSECPU
#define _HDLOAD_OSECPU 1

// プロジェクトのすべてのファイルで読み込むヘッダ


/* Visual Studio で fopen()やsprintf() などの古い関数を使用する時に出る警告を抑止する*/
#define _CRT_SECURE_NO_WARNINGS 1

#include <stdio.h>
#include <string.h>
#include <limits.h>
#include <time.h>
#include <setjmp.h>
#include <stdlib.h>

struct PtrCtrl {
	int liveSign;
	int size, typ;
	unsigned char *p0;
};

struct Ptr {	/* 32バイト(=256bit!) */
	unsigned char *p;
	int typ;
	unsigned char *p0, *p1;
	int liveSign;
	struct PtrCtrl *pls;
	int flags, dummy;	/* read/writeなど */
};

struct LabelTable {
	unsigned char *p, *p1;
	int opt;
	
	/*
	 * default = -1
	 * TYP_CODE = 0
	 * T_UINT8 = 3
	 *
	 * 将来的には UInt8, SInt32, Flt64, UInt8, VPtr が使えるようになる　http://osecpu.osask.jp/wiki/?page0053
	 */
	int typ;
};

struct Regs {
	int ireg[64]; /* 32bit整数レジスタ */
	struct Ptr preg[64];	/* ポインタレジスタ */

	int debugInfo0, debugInfo1, dmy[2]; /* 2304 */
	struct PtrCtrl *ptrCtrl; /* 2320 */
	char winClosed, autoSleep;
	jmp_buf *setjmpEnv;

	/* for-junkApi */
	int argc;
	const unsigned char **argv;
	unsigned char *buf0, *buf1, *junkStack, lastConsoleChar, *junkStack1;

	struct LabelTable *label;
	int maxLabels;
	unsigned char *jitbuf, *jitbuf1;
	void(*errHndl)(struct Regs *);
	char dbgr;
	int mapDi1s[16][16];
};

#define KEY_ENTER		'¥n'
#define KEY_ESC			27
#define KEY_BACKSPACE	8
#define KEY_TAB			9
#define KEY_PAGEUP		0x1020
#define KEY_PAGEDWN		0x1021
#define	KEY_END			0x1022
#define	KEY_HOME		0x1023
#define KEY_LEFT		0x1024
#define KEY_UP			0x1025
#define KEY_RIGHT		0x1026
#define KEY_DOWN		0x1027
#define KEY_INS			0x1028
#define KEY_DEL			0x1029

static int *keybuf, keybuf_r, keybuf_w, keybuf_c;
static int *vram = NULL, v_xsiz, v_ysiz;

//デバッグ用。プログラム中の随所で加算される変数
static int di1_serial = 0;

// main.c
void putKeybuf(int i);

#include "switch.h"
#include "function.h"
#include "dependent.h"
#include "jitc.h"
#include "screen.h"
#include "comlib.h"

#if (USE_TEK5 != 0)

/* tek.cを移植するのは大変だと思ったので、断念 */
#error "tek is not supported. edit switch.h and set USE_TEK5=0"

//	#include "tek.c"
//	int tek5Decomp(unsigned char *buf, unsigned char *buf1, unsigned char *tmp);
#endif


#endif

